/**************************************************************************//**
 * @file main.cpp
 * @brief This file contains main loop
 * @author Dawid Bazan <dawidbazan@gmail.com>
 * @author Dariusz Synowiec <devemouse@gmail.com>
 * @version 0.0
 * @date    May 2011
 * @bug There is no bug. left this to have a reference.
 * @warning This was never programmed to the uC yet.
 *****************************************************************************/

/** 
 * \mainpage My Personal Index Page
 *
 * \section intro_sec Introduction
 *
 * This is the introduction.
 *
 * \section install_sec Installation
 *
 * \subsection step1 Step 1: Opening the box
 *
 * etc...
 */


#include "core/LPC17xx.h"
//#include <new>



//#define VERSION_STRING "V1.2.0 12/2009"


volatile uint32_t msTicks;                            /* counts 1ms timeTicks */
/*----------------------------------------------------------------------------
  SysTick_Handler
 *----------------------------------------------------------------------------*/
void SysTick_Handler(void) {
  msTicks++;                        /* increment counter necessary in Delay() */
}

/*------------------------------------------------------------------------------
  delays number of tick Systicks (happens every 1 ms)
 *------------------------------------------------------------------------------*/
__INLINE static void Delay (uint32_t dlyTicks) {
  uint32_t curTicks;

  curTicks = msTicks;
  while ((msTicks - curTicks) < dlyTicks);
}

/*------------------------------------------------------------------------------
  configer LED pins
 *------------------------------------------------------------------------------*/
__INLINE static void LED_Config(void) {

  LPC_GPIO1->FIODIR = 0xFFFFFFFF;               /* LEDs PORT1 are Output */
  LPC_GPIO0->FIODIR = 0xFFFFFFFF;
}

/*------------------------------------------------------------------------------
  Switch on LEDs
 *------------------------------------------------------------------------------*/
__INLINE static void LED_On (uint32_t led) {

  LPC_GPIO1->FIOPIN |=  (led);                  /* Turn On  LED */
}

/**************************************************************************//**
 * LED_Off
 * Turns off a led connected to some pin
 *
 * @param uint32_t led channel
 *
 *****************************************************************************/
__INLINE static void LED_Off (uint32_t led) {

  LPC_GPIO1->FIOPIN &= ~(led);                  /* Turn Off LED */
}



        void _delay(uint32_t del){
            volatile uint32_t temp;
            uint32_t i;
            for(i=0;i<del;i++)
                    temp = i;
        }


class A{
	public:
	A(){}

};

/**************************************************************************//**
 * main
 * Function from which everything starts...
 *
 * @return on embedded targets this function shall never return
 *
 *****************************************************************************/
int main(void){
	  A* a = new A();
	  LED_Config();

	  while(1) {
	    LED_On ((1<<30));                           /* Turn on the LED. */
	    _delay(1 << 20 );                                /* delay  100 Msec */
	    LED_Off ((1<<30));                          /* Turn off the LED. */
	    _delay(1 << 20 );                              /* delay  100 Msec */

	  }
	  return 0;
}

